<template>
  <div
    class="ob-textarea textarea-wrapper"
    :class="{ disabled, readonly, invalid: isInvalid }"
  >
    <div class="textarea-label">
      {{ label }}
      <span
        v-if="required"
        class="textarea-label-required -light-raspberry-red"
      >
        *
      </span>
    </div>
    <textarea
      ref="ob-textarea"
      data-attr="ob-textarea"
      :style="style"
      :value="value"
      :placeholder="placeholder"
      :disabled="disabled || readonly"
      :required="required"
      :maxlength="maxLength"
      :data-qa="dataQa"
      @input="$emit('input', $event.target.value)"
      @focus="onFocus"
      @blur="onBlur"
    />
    <div
      v-if="isInvalid"
      class="main-icon"
    >
      <ob-tooltip
        :disabled="disabled || readonly"
        type="error"
        :content="mainError.text"
        position="top-end"
        :open-delay="500"
      >
        <i
          class="icon alert"
          :data-qa="dataQa"
        />
      </ob-tooltip>
    </div>
  </div>
</template>
<script>
import FormItemMixin from '../obForm/FormItemMixin'
import ObTooltip from '../../obComponents/obTooltip'
export default {
  name: 'ObTextarea',
  components: {
    ObTooltip
  },
  mixins: [
    FormItemMixin
  ],
  props: {
    value: {
      type: String,
      default: null
    },
    label: {
      type: String,
      required: false
    },
    placeholder: {
      type: String,
      required: false
    },
    required: {
      type: Boolean,
      required: false
    },
    disabled: {
      type: Boolean,
      required: false
    },
    readonly: {
      type: Boolean,
      required: false
    },
    invalid: {
      type: Boolean,
      default: () => null
    },
    property: {
      type: [String, Array],
      default: null
    },
    exactHeight: {
      type: String,
      required: false
    },
    maxLength: {
      type: [String, Number],
      default: () => ''
    },
    dataQa: {
      type: String
    }
  },
  computed: {
    isInvalid () {
      return this.invalid || this.mainError
    },
    style () {
      return {
        ...(this.exactHeight && {
          'height': this.exactHeight,
          'resize': 'none'
        })
      }
    }
  },
  methods: {
    onFocus (e) {
      this.$emit('focus', e.target.value)
    },
    onBlur (e) {
      this.touchField()

      this.$emit('blur', e.target.value)
    }
  }
}
</script>
<style lang="scss" scoped>
@import "../../static/css/mixins";
$transition-timing: .2s cubic-bezier(.645,.045,.355,1);

.textarea-wrapper {
  position: relative;
  width: 100%;

  &:hover {
    textarea {
      border: 1px solid $cornflower-craiola;
    }
  }

  &:focus {
    textarea {
      border: 1px solid $blue-700;
    }
  }

  &.invalid {
    textarea {
      border-color: $color-error;
    }
  }

  &.disabled {
    .textarea-label {
      color: $color-grey-span;
      background: $color-white-lilac;
    }

    textarea {
      color: $color-grey-span;
      background: $color-white-lilac;
      border-color: $color-white-lilac;
    }

    .main-icon {
      display: none;
    }
  }

  &.readonly {
    .textarea-label {
      background: $color-white-lilac;
    }

    textarea {
      background: $color-white-lilac;
      border-color: $color-white-lilac;
    }

    .main-icon {
      display: none;
    }
  }
}

.textarea-label {
  @include font-mixin(12px, 12px, 400, $gray-slate, 0.4px);
  position: absolute;
  top: 1px;
  left: 1px;
  width: calc(100% - 2px);
  padding: 7px 12px 8px;
  transition: background $transition-timing,
  color $transition-timing;
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
  background: $background-white;
  border-radius: 2px 2px 0 0;

  &.disabled {
    color: $color-grey-span;
  }
}

textarea {
  @include font-mixin(16px, 20px, 400, $color-text-base, 0.2px);
  max-width: 100%;
  min-width: 100%;
  margin: 0 !important;
  display: block;
  border: 1px solid $color-grey-border;
  background: $background-white;
  box-sizing: border-box;
  border-radius: 3px;
  outline: none;
  width: 100%;
  height: 72px;
  padding: 24px 11px 0;
  transition: border-color $transition-timing,
  background $transition-timing,
  color $transition-timing;
  appearance: none;
  resize: vertical;

  &::placeholder {
    color: $gray-window;
  }

  &:focus {
    border-color: $color-blue-navy-blue;
  }
}

.main-icon {
  z-index: 100;
  position: absolute;
  top: 12px;
  right: 12px;
  display: flex;
  justify-content: center;
  align-items: center;
  margin-left: 12px;
  cursor: default;
  i {
    display: flex;
    justify-content: center;
    align-items: center;
    font-size: 24px;
    color: $color-error;
    &.--clickable {
      cursor: pointer;
    }
  }

  .--disabled & {
    color: inherit !important;
  }
}
</style>
